// Header File
// Created 2/8/2005; 8:16:59 PM
#ifndef _COL_DETECT
#define _COL_DETECT
//these functions are put here because they are used only once and it is easier (and smaller?) to put them here
	/*        64
	|------|   |------------|
	   39              89
		 |------------|   |-----------|
	30      55      80     105      130
	--------------------------------0  -
	|       |       |       |       |  
	|   W0  |  W1   |   W2  |  W3   |  -9
	|       |       |       |       |  
	--------------------------------25 -
	|       |       |       |       |   
	|   W4  |  W5   |   W6  |  W7   |   -34
	|       |       |       |       |   
	--------------------------------50  -
	|       |       |       |       |    
	|   W8  |  W9   |  W10  | W11   |    -59
	|       |       |       |       |    
	--------------------------------75   -
	|       |       |       |       |     
	|  W12  | W13   |  W14  | W15   |     
	|       |       |       |       |     
	--------------------------------100   -*/
	extern inline short __attribute__((__regparm__(3))) on_space_89(short x,short y,WALL wall)
	{
		//row0
		if(wall.Wbits.W0          && x<55           && y<25) //30,0,55,25
			return FALSE;
		if(wall.Wbits.W1  && x>39 && x<80           && y<25) //55,0,80,25
			return FALSE;
		if(wall.Wbits.W2  && x>64 && x<105          && y<25) //105,0,80,25
			return FALSE;
		if(wall.Wbits.W3  && x>89                   && y<25) //130,0,105,25
			return FALSE;
		//row1
		if(wall.Wbits.W4           && x<55  && y>9  && y<50) //30,50,55,25
			return FALSE;
		if(wall.Wbits.W5  && x>39  && x<80  && y>9  && y<50) //80,50,55,25
			return FALSE;
		if(wall.Wbits.W6  && x>64  && x<105 && y>9  && y<50) //80,50,105,25
			return FALSE;
		if(wall.Wbits.W7  && x>89           && y>9  && y<50) //130,50,105,25
			return FALSE;
		//row2
		if(wall.Wbits.W8           && x<55  && y>34 && y<75) //30,50,55,75
			return FALSE;
		if(wall.Wbits.W9  && x>39  && x<80  && y>34 && y<75) //80,50,55,75
			return FALSE;
		if(wall.Wbits.W10 && x>64  && x<105 && y>34 && y<75) //80,50,105,75
			return FALSE;
		if(wall.Wbits.W11 && x>89           && y>34 && y<75) //130,50,105,75
			return FALSE;
		//row3
		if(wall.Wbits.W12          && x<55  && y>59        ) //30,75,55,100
			return FALSE;
		if(wall.Wbits.W13 && x>39  && x<80  && y>59        ) //80,75,55,100
			return FALSE;
		if(wall.Wbits.W14 && x>64  && x<105 && y>59        ) //80,75,80,100
			return FALSE;
		if(wall.Wbits.W15 && x>89           && y>59        ) //130,75,105,100
			return FALSE;
		//otherwise we return true
		return TRUE;
	}
	/*        104
	|------|   |------------|
	   72              136
		 |------------|   |-----------|
	56      88     120      152    184
	--------------------------------0  -
	|       |       |       |       |  
	|   W0  |  W1   |   W2  |  W3   |  -16
	|       |       |       |       |  
	--------------------------------32 -
	|       |       |       |       |   
	|   W4  |  W5   |   W6  |  W7   |   -48
	|       |       |       |       |   
	--------------------------------64  -
	|       |       |       |       |    
	|   W8  |  W9   |  W10  | W11   |    -80
	|       |       |       |       |    
	--------------------------------96   -
	|       |       |       |       |     
	|  W12  | W13   |  W14  | W15   |     
	|       |       |       |       |     
	--------------------------------128   -*/
	extern inline short __attribute__((__regparm__(3))) on_space_92plus_and_v200(short x,short y,WALL wall)
	{
		//row0
		if(wall.Wbits.W0           && x<88           && y<32) //30,0,55,32
			return FALSE;
		if(wall.Wbits.W1  && x>72  && x<120          && y<32) //55,0,80,32
			return FALSE;
		if(wall.Wbits.W2  && x>104 && x<152          && y<32) //105,0,80,32
			return FALSE;
		if(wall.Wbits.W3  && x>136                   && y<32) //130,0,105,32
			return FALSE;
		//row1
		if(wall.Wbits.W4            && x<88  && y>16  && y<64) //30,64,55,32
			return FALSE;
		if(wall.Wbits.W5  && x>72   && x<120 && y>16  && y<64) //80,64,55,32
			return FALSE;
		if(wall.Wbits.W6  && x>104  && x<152 && y>16  && y<64) //80,64,105,32
			return FALSE;
		if(wall.Wbits.W7  && x>136          && y>16  && y<64) //130,64,105,32
			return FALSE;
		//row2
		if(wall.Wbits.W8            && x<88  && y>48  && y<96) //30,64,55,96
			return FALSE;
		if(wall.Wbits.W9  && x>72   && x<120 && y>48  && y<96) //80,64,55,96
			return FALSE;
		if(wall.Wbits.W10 && x>104  && x<152 && y>48  && y<96) //80,64,105,96
			return FALSE;
		if(wall.Wbits.W11 && x>136           && y>48  && y<96) //130,64,105,96
			return FALSE;
		//row3
		if(wall.Wbits.W12           && x<88  && y>80         ) //30,96,55,100
			return FALSE;
		if(wall.Wbits.W13 && x>72   && x<120  && y>80        ) //80,96,55,100
			return FALSE;
		if(wall.Wbits.W14 && x>104  && x<152 && y>80         ) //80,96,80,100
			return FALSE;
		if(wall.Wbits.W15 && x>136           && y>80         ) //130,96,105,100
			return FALSE;
		//otherwise we return true
		return TRUE;
	}
#endif