// Header File
// Created 2/4/2005; 5:55:49 PM
#ifndef _MAC
#define _MAC
//internel macros to get a macro to expand to a string
#define _str(s) __str(s)
#define __str(s) #s

#ifndef USE_FLINE_ROM_CALLS
	#define ASM_ROM_CALL(num)  	"	movea.l "_str(num)"*4(%a5),%a0\n	jsr (%a0)\n"
	#define INLINE_ASM_ROM_CALL(num)  	"	movea.l "_str(num)"*4(%%a5),%%a0\n	jsr (%%a0)\n"
#else
	#define ASM_ROM_CALL(num)	"	.word _F_LINE+"_str(num)"\n"
	#define INLINE_ASM_ROM_CALL ASM_ROM_CALL
#endif

//"borrowed" from HSR, by Greg Dietsche. this set's the dirty flag so the middle of the screen is redrawn on return to AMS
	#define setDirty()   ({WINDOW *dummy;asm volatile(\
	"____dirtywindows:\n"\
	"	ori.w    #0x2000,(%[Win])        | set Dirty Flag\n"\
	"	tst.l    (0x22,%[Win])           | is there another window?\n"\
	"	movea.l  (0x22,%[Win]),%[Win]       | movea does not affect ccr\n"\
	"	bne.s    ____dirtywindows":[Win]"=a"(dummy):"0"(FirstWindow):"cc");})

#define ST_emptyMsg _rom_call(void,(void),E6)

//another part of HSR, by Greg Dietsche. it just redraws the statln. not used if a message is displayed on exit.
	#define ST_reset() ({ST_emptyMsg();(void)ST_eraseHelp();})

//SB is a programer contraction for small big meaning that the first, small, value is for the small screen
//and the seccond, big, value is for the small screen. basicly it is alot smaller than PSUDO_CONST_SCREEN
#define SB PSEUDO_CONST_SCREEN

//turns an arrow keypress from a big kbd to an arrow keypress from a small kbd
#define translateArrows(val) ({short tval=val;asm("move.w %[key],%%d1\n"\
					"	and.w #0x0FF0,%%d1\n"\
					"	cmp.w #0x150,%%d1\n"\
					"jbne done\n"\
					"	btst.b #1,%[key]\n"\
					"	jbeq not_up\n"\
					"	bset.b #0,%%d1\n"\
					"not_up:\n"\
					"	btst.b #2,%[key]\n"\
					"	jbeq not_right\n"\
					"	bset.b #3,%%d1\n"\
					"not_right:\n"\
					"	btst.b #3,%[key]\n"\
					"	jbeq not_dn\n"\
					"	bset.b #2,%%d1\n"\
					"not_dn:\n"\
					"	btst.b #0,%[key]\n"\
					"	jbeq not_left\n"\
					"	bset.b #1,%%d1\n"\
					"not_left:\n"\
					"	move.b %%d1,%[dest]\n"\
					"done:":[dest]"+g"(tval):[key]"g"(val):"d1");tval;})
					
#define removeDmd(key) ({char tmp;asm volatile("bclr.l %[bit],%[val]\n	sne.b %[dest]":[dest]"=d"(tmp),[val]"=d"(key):"1"(key),[bit]"di"(isBigKBD()?13:14));tmp;})

#define isBigKBD() (PSEUDO_CONST_KBD(FALSE,TRUE))

#define testWall(val,x,y) ({char tmp;asm("btst.b %[bit],(%[wrd].w,%[addr])\n	sne %[rslt]":[rslt]"=d"(tmp):[addr]"a"(&(val)),[bit]"d"(8-(x+1+4*y)),[wrd]"d"((short)(y>1?1:0)));tmp;})

#define remove2nd(key) ({char tmp;asm volatile("bclr.l #12,%[val]\n	sne.b %[dest]":[dest]"=d"(tmp),[val]"=d"(key):"1"(key));tmp;})

#define setWall(val,x,y) asm("bchg.b %[bit],(%[wrd].w,%[addr])"::[addr]"a"(&val),[bit]"d"(8-(x+1+4*y)),[wrd]"d"((short)(y>1?1:0)))

#define randomizeWall(_dif) ({unsigned short tmp,dummy;\
						asm(\
						"	move.b 0x600017,%%d0\n"\
						"	moveq.l #-1,%[dest]\n"\
						"makeHole:\n"\
						"	lsr.b    #1,%%d0\n"\
    				"	bcc.s    1f\n"\
    				"	eori.b   #0xA3,%%d0\n"\
						"	1:\n"\
						"	moveq.l #-2,%%d1\n"\
						"	rol.w %%d0,%%d1\n"\
						"	and.w %%d1,%[dest]\n"\
						"	dbf      %[dif],makeHole\n"\
						:[dest]"=d" (tmp),[dif]"=d" (dummy):"1" (_dif-1):"d0","d1","cc");(WALL)tmp;})


	#define DrawStrs(ySt,Strs,num) 	({short dummy,dummy0;void *dummy1;\
	if(__builtin_constant_p(LCD_WIDTH)){\
		asm volatile(\
	 	"	subq.l #1,%[lc]\n"\
	 "draw_loop:\n"\
		"	move.l (%[str]),-(%%sp)\n"\
	 	INLINE_ASM_ROM_CALL(0x27E)\
	 	"	moveq.l %[center],%%d1\n"\
	 	"	mulu.w #3,%%d0\n"\
	 	"	sub.w %%d0,%%d1\n"\
		"	clr.w -(%%sp)\n"\
		"	move.l (%[str])+,-(%%sp)\n"\
		"	move.w %[yPos],-(%%sp)\n"\
		"	move.w %%d1,-(%%sp)\n"\
		INLINE_ASM_ROM_CALL(0x1A9)\
		"	lea (14,%%sp),%%sp\n"\
		"	add.w #10,%[yPos]\n"\
		"	dbf %[lc],draw_loop\n":[str]"=a" (dummy1),[yPos]"=d" (dummy),[lc] "=d"(dummy0):"0" (Strs),"1" (ySt),"2"(num),[center] "gi"((LCD_WIDTH)/2):"a0","a1","d0","d1","d2","cc");\
		}else{\
			asm volatile(\
	 	"	subq.l #1,%[lc]\n"\
	 	"draw_loop:\n"\
		"	move.l (%[str]),-(%%sp)\n"\
	 	INLINE_ASM_ROM_CALL(0x27E)\
	 	"	move.l %[center],%%d1\n"\
	 	"	mulu.w #3,%%d0\n"\
	 	"	sub.w %%d0,%%d1\n"\
		"	clr.w -(%%sp)\n"\
		"	move.l (%[str])+,-(%%sp)\n"\
		"	move.w %[yPos],-(%%sp)\n"\
		"	move.w %%d1,-(%%sp)\n"\
		INLINE_ASM_ROM_CALL(0x1A9)\
		"	lea (14,%%sp),%%sp\n"\
		"	add.w #10,%[yPos]\n"\
		"	dbf %[lc],draw_loop\n":[str]"=a" (dummy1),[yPos]"=d" (dummy),[lc] "=d"(dummy0):"0" (Strs),"1" (ySt),"2"(num),[center] "d"((LCD_WIDTH)/2):"a0","a1","d0","d1","d2","cc");}})

#define isSmallScreen() PSEUDO_CONST_SCREEN(TRUE,FALSE)


#endif